include </home/maride/Projekte/3dlib/rohr.scad>

WIDTH_TOTAL = 1800;
HEIGHT_TOTAL = 760;
DEPTH_TOTAL = 900;

ROHRDICKE = 30;
ROHR = [ROHRDICKE, ROHRDICKE, 1.5];
PLATTE_DICKE = 20;

module main() {
    // Bein vorn
    rotate([90, 0, 0])
    rohr(ROHR, HEIGHT_TOTAL - PLATTE_DICKE);
    
    // Bein hinten
    translate([0, DEPTH_TOTAL - ROHRDICKE, 0])
    rotate([90, 0, 0])
    rohr(ROHR, HEIGHT_TOTAL - PLATTE_DICKE);
    
    // Querstrebe unten
    translate([0, ROHRDICKE/2, ROHRDICKE/2])
    rohr(ROHR, DEPTH_TOTAL - ROHRDICKE*2);
    
    // Querstrebe oben
    translate([0, ROHRDICKE/2, HEIGHT_TOTAL - PLATTE_DICKE - ROHRDICKE/2])
    rohr(ROHR, DEPTH_TOTAL - ROHRDICKE*2);
}

main();